Перем ТекущаяЗаписьXML;
Перем ДатаГенерации;
Перем ИмяПроекта;
Перем ПутьКИсходникам;

// Выполняет формирование отчета
//
// Параметры:
//   ДанныеСтатистикиПокрытия - Соответствие - Прочитанные данные статистики OScript
//   ПутьКОтчетуClover - Строка - Путь к файлу отчета
//
Процедура Сформировать(Знач ДанныеСтатистикиПокрытия, Знач ПутьКОтчетуClover) Экспорт

	ДанныеПокрытия = ДанныеСтатистикиПокрытия;

	ТекущаяЗаписьXML = Новый ЗаписьXML;
	ТекущаяЗаписьXML.ОткрытьФайл(ПутьКОтчетуClover);
	ТекущаяЗаписьXML.ЗаписатьОбъявлениеXML();
	
	ДатаГенерации = ДатуВTimestamp(ТекущаяДата());

	ТекущаяЗаписьXML.ЗаписатьНачалоЭлемента("coverage");
	ТекущаяЗаписьXML.ЗаписатьАтрибут("clover", "1.0");
	ТекущаяЗаписьXML.ЗаписатьАтрибут("generated", ДатаГенерации);
	
	ДобавитьОписаниеПроекта(ИмяПроекта);
	ДобавитьОписаниеПакета("main");

	ВсегоФайловВПакете = 0;
	МетрикаПакета = Новый Структура;

	Файлы = ДанныеПокрытия.Скопировать(, "ПутьКФайлу");
	Файлы.Свернуть("ПутьКФайлу");
	Файлы = Файлы.ВыгрузитьКолонку("ПутьКФайлу");

	Для Каждого ПутьКФайлу Из Файлы Цикл

		ВсегоФайловВПакете = ВсегоФайловВПакете + 1;

		ФайлПокрытия = Новый Файл(ПутьКФайлу);
		ИмяФайла = ФайлПокрытия.Имя;
		КаталогФайла = ФайлПокрытия.Путь;
		ТекущаяЗаписьXML.ЗаписатьНачалоЭлемента("file");
		ТекущаяЗаписьXML.ЗаписатьАтрибут("name", ИмяФайла);
		ТекущаяЗаписьXML.ЗаписатьАтрибут("path", КаталогФайла);

		КоличествоМетодов         = 0;
		КоличествоПокрытыхМетодов = 0;
		ОбщееВремяВыполнения      = 0;
		ВсегоСтрокВФайле          = 0;
		ВсегоЭлементов            = 0;
		ВсегоПокрытоЭлементов     = 0;

		ДанныеФайла = ДанныеПокрытия.НайтиСтроки(Новый Структура("ПутьКФайлу", ПутьКФайлу));

		ТекущийМетод = Неопределено;

		Для Каждого СтрокаДанныхФайла Из ДанныеФайла Цикл

			ИмяМетода = СтрокаДанныхФайла.ИмяМетода;

			Если ТекущийМетод <> ИмяМетода Тогда
				КоличествоМетодов = КоличествоМетодов + 1;
				ТекущийМетод = ИмяМетода;
			КонецЕсли;

			ТипСтроки = ?(ИмяМетода = "$entry", "stmt", "method");

			ТекущаяЗаписьXML.ЗаписатьНачалоЭлемента("line");

			ТекущаяЗаписьXML.ЗаписатьАтрибут("num", СтрокаДанныхФайла.СтрокаМодуля);
			ТекущаяЗаписьXML.ЗаписатьАтрибут("type", ТипСтроки);
			ТекущаяЗаписьXML.ЗаписатьАтрибут("count", СтрокаДанныхФайла.КоличествоВызовов);

			ТекущаяЗаписьXML.ЗаписатьКонецЭлемента(); // lineToCover

			ОбщееВремяВыполнения = ОбщееВремяВыполнения + СтрокаДанныхФайла.ВремяВыполнения;

			ВсегоСтрокВФайле = Макс(ВсегоСтрокВФайле, СтрокаДанныхФайла.СтрокаМодуля);

			ВсегоЭлементов        = ВсегоЭлементов + 1;
			ВсегоПокрытоЭлементов = ВсегоПокрытоЭлементов + СтрокаДанныхФайла.Покрыто;

		КонецЦикла;

		ИмяКласса = ФайлПокрытия.ИмяБезРасширения;
		ТекущаяЗаписьXML.ЗаписатьНачалоЭлемента("class");
		ТекущаяЗаписьXML.ЗаписатьАтрибут("name", ИмяКласса);
		МетрикаКласса = ПодготовитьМетрикиКласса(
			ВсегоЭлементов,
			ВсегоПокрытоЭлементов,
			КоличествоМетодов,
			КоличествоПокрытыхМетодов,
			ОбщееВремяВыполнения
		);

		ЗаписатьЭлементXML("metrics", МетрикаКласса);
		ТекущаяЗаписьXML.ЗаписатьКонецЭлемента(); // file

		ПолучитьМетрикуФайла(ВсегоСтрокВФайле, МетрикаКласса);

		ЗаписатьЭлементXML("metrics", МетрикаКласса);
		ТекущаяЗаписьXML.ЗаписатьКонецЭлемента(); // file

		ДобавитьМетрикуВМетрикуПакета(МетрикаПакета, МетрикаКласса);

	КонецЦикла;

	МетрикаПакета.Вставить("files", ВсегоФайловВПакете);
	ЗаписатьЭлементXML("metrics", МетрикаПакета);
	
	ТекущаяЗаписьXML.ЗаписатьКонецЭлемента(); // Пакеи
	
	МетрикаПакета.Вставить("packages", 1);
	ЗаписатьЭлементXML("metrics", МетрикаПакета);
	
	ТекущаяЗаписьXML.ЗаписатьКонецЭлемента(); // Проект

	ТекущаяЗаписьXML.ЗаписатьКонецЭлемента(); // coverage
	
	ТекущаяЗаписьXML.Закрыть();

КонецПроцедуры

Процедура ЗаписатьЭлементXML(ИмяЭлемента, Атрибуты)
	
	ДобавитьЭлементXML(ИмяЭлемента, Атрибуты);

	ТекущаяЗаписьXML.ЗаписатьКонецЭлемента(); // coverage

КонецПроцедуры


Функция ПолучитьМетрикуФайла(ВсегоСтрокКода, МетрикаКласса)
	
	МетрикаКласса.Вставить("classes", 1);
	МетрикаКласса.Вставить("loc", ВсегоСтрокКода);
	МетрикаКласса.Вставить("ncloc", ВсегоСтрокКода - МетрикаКласса.elements);

	Возврат МетрикаКласса;

КонецФункции

Процедура ДобавитьМетрикуВМетрикуПакета(МетрикаПакета, МетрикаКласса)

	Для каждого КлючИЗначение Из МетрикаКласса Цикл
		
		ЗначениеМетрикиПакета = Неопределено;

		Если Не МетрикаПакета.Свойство(КлючИЗначение.Ключ, ЗначениеМетрикиПакета) Тогда
			МетрикаПакета.Вставить(КлючИЗначение.Ключ, КлючИЗначение.Значение);
		Иначе
			МетрикаПакета.Вставить(КлючИЗначение.Ключ, КлючИЗначение.Значение + ЗначениеМетрикиПакета);
		КонецЕсли;

	КонецЦикла;
	
КонецПроцедуры

Функция ПодготовитьМетрикиКласса(ВсегоЭлементов, ВсегоПокрытоЭлементов,
							ВсегоМетодов, ВсегоПокрытоМетодов,
							ВремяВыполнения)

	Метрики = Новый Структура();

	// Обязательные атрибуты 

	Метрики.Вставить("complexity", 0); // Не считает Oscript 
	Метрики.Вставить("elements", ВсегоЭлементов); 
	Метрики.Вставить("coveradelements", ВсегоПокрытоЭлементов); 
	Метрики.Вставить("conditionals", 0); // Не считает Oscript
	Метрики.Вставить("coveredconditionals", 0); // Не считает Oscript

	Метрики.Вставить("statements", ВсегоЭлементов); 
	Метрики.Вставить("coveredstatements", ВсегоПокрытоЭлементов); 
	
	Метрики.Вставить("methods", ВсегоМетодов); 
	Метрики.Вставить("coveredmethods", ВсегоПокрытоМетодов); 

	Метрики.Вставить("testduration", ВремяВыполнения); 

	Возврат Метрики;

КонецФункции

Процедура ДобавитьЭлементXML(ИмяЭлемента, АтрибутыЭлемента)
	
	ТекущаяЗаписьXML.ЗаписатьНачалоЭлемента(ИмяЭлемента);

	Для каждого АтрибутЭлемента Из АтрибутыЭлемента Цикл
		ТекущаяЗаписьXML.ЗаписатьАтрибут(АтрибутЭлемента.Ключ, АтрибутЭлемента.Значение);
	КонецЦикла;
		
КонецПроцедуры

Процедура ДобавитьОписаниеПроекта(ИмяПроекта)
	
	Атрибуты = Новый Структура("name, timestamp", ИмяПроекта, ДатаГенерации);

	ДобавитьЭлементXML("project", Атрибуты);

КонецПроцедуры

Процедура ДобавитьОписаниеПакета(ИмяПакета)
	
	Атрибуты = Новый Структура("name", ИмяПакета);

	ДобавитьЭлементXML("package", Атрибуты);

КонецПроцедуры

Процедура ПриСозданииОбъекта(Знач КаталогИсходников, Знач ВходящееИмяПроекта)
	ПутьКИсходникам = Новый Файл(КаталогИсходников).ПолноеИмя;
	ИмяПроекта = ВходящееИмяПроекта;
КонецПроцедуры

Функция ДатуВTimestamp(ВходящаяДата = Неопределено)
	Возврат Формат(Число( ?(ТипЗнч(ВходящаяДата) = Тип("Дата"), ВходящаяДата, ТекущаяДата()) 
					- Дата("19700101")), "ЧН=0; ЧГ=0");
КонецФункции